<?php
namespace Teknisa\EST\Modules\Ajuste\Controllers;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\FilterCriteria;


class RecalculoEstoq extends \Teknisa\EST\Controllers\TeknisaCrud {

    protected $service;
    protected $dataSourceName = 'prodlcestoq_valida_recalculo';
    protected $newCode;
    protected $parameterBagColumns=['CDFILIAL','NRORG'];
    
    public function __construct ($crudService,$parameterBag,$service,$newCode,$environment){
    	parent::__construct($crudService,$parameterBag);
        $this->service = $service;
        $this->newCode = $newCode;
        $this->environment = $environment;
    }
     
    public function recalcularEstoque(Row $request, Response $response) {
	    $nrmovilote= '';
		try {
		    $row = $request->getRow();
		    $this->dataSourceName = 'prodlcestoq_valida_recalculo';
		    $conditions = array(
		        array(
		            'columnName'=>'CDFILIAL',
		            'operator'=>'=',
		            'value' => $row['CDFILIAL']
		        )    
		    );
		    $filterCriteria = new FilterCriteria($this->dataSourceName,$conditions);
		    $newRequest = new Filter($filterCriteria,$request->getMethod(),$request->getRoutePath(),$request->getUserId());
		    parent::find($newRequest,$response);
		    $rowValidacao = $response->getDataSets()[0]->getRows()[0];
		    $response->setDataSets([]);
		    if(!$rowValidacao['DTMIN'] && !$rowValidacao['PRODFIM'] && !$rowValidacao['PRODINI']){
			    throw new \Exception('Não existem produtos cadastrados para recálculo');
		    }else{
			    $this->service->deletePosestdia($row['DTRECALC'],$row['CDFILIAL'],$row['CDALMOXARIFE'],$row['CDLOCALESTOQ'],$row['CDPRODINI'],$row['CDPRODFIN']);
			    $this->service->deletePosestatu($row['DTRECALC'],$row['CDFILIAL'],$row['CDALMOXARIFE'],$row['CDLOCALESTOQ'],$row['CDPRODINI'],$row['CDPRODFIN']);
			    $nrmovilote = $this->newCode->getCodeByTableName('RECALESTOQ', $this->environment->getNrOrgTrab());
			    $this->service->insereMovilote($row['DTRECALC'],$row['CDFILIAL'],$row['CDALMOXARIFE'],$row['CDLOCALESTOQ'],$row['CDPRODINI'],$row['CDPRODFIN'],$row['CDFILIAL'].$nrmovilote);
				$this->service->insertLogopera($row['CDFILIAL'],$row['CDALMOXARIFE'],$row['CDLOCALESTOQ'],$row['CDPRODINI'],$row['CDPRODFIN'],$row['DTRECALC']);
				$produtosIrregulares = $this->service->atualizaEstoque($row['CDFILIAL'],$nrmovilote,$row['DTRECALC']);
				if (!empty($produtosIrregulares)){
					$response->setError(new Error($produtosIrregulares, 500));
				}
		    }
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
		$this->service->deleteMovilote($nrmovilote);
	}
}