<?php

namespace Teknisa\EST\Modules\Ajuste\Factories;

use Doctrine\ORM\EntityManager;
    
class LanctoestoqAjusteFactory {
    
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }
    
    public function getProdutoTabela($parameters){
        $sql = "";
        if(isset($parameters["P_CDARVPROD"])){
           $sql = "SELECT DISTINCT PF.CDFILIAL,
                        P.CDPRODUTO,
                        P.CDARVPROD,
                        P.NMPRODUTO,
                        P.SGUNIDADE,
                        P.VRFATOCONV,
                        P.CDPRODESTO AS CDPRODMOVI,
                        P.NRORG,
                        ' ' AS CDALMOXARIFE,
                        ' ' AS CDLOCALESTOQ,
                        ' ' AS NRLOTEESTQ,
                        ' ' AS NRSUBLOTE,
                        0 AS VRUNILANCTO,
                        0 AS VRTOTLANCTO,
                        0 AS VRLANCTOEST,
                        0 AS VRUNITBRUT,
                        0 AS QTTOTLANCTO
                    FROM
                        PRODUTO P JOIN
                        PRODFILI PF ON P.CDPRODUTO = PF.CDPRODUTO
                    WHERE
                        P.CDARVPROD = :P_CDARVPROD AND
                        PF.CDFILIAL = :P_CDFILIAL"; 
        }else if(isset($parameters["P_CDBARPRODUTO"])){
            $sql = "SELECT DISTINCT PF.CDFILIAL,
                        P.CDPRODUTO,
                        P.CDARVPROD,
                        P.NMPRODUTO,
                        P.SGUNIDADE,
                        P.VRFATOCONV,
                        P.CDPRODESTO AS CDPRODMOVI,
                        P.NRORG,
                        ' ' AS CDALMOXARIFE,
                        ' ' AS CDLOCALESTOQ,
                        ' ' AS NRLOTEESTQ,
                        ' ' AS NRSUBLOTE,
                        0 AS VRUNILANCTO,
                        0 AS VRTOTLANCTO,
                        0 AS VRLANCTOEST,
                        0 AS VRUNITBRUT,
                        0 AS QTTOTLANCTO
                    FROM
                        PRODUTO P JOIN
                        PRODFILI PF ON P.CDPRODUTO = PF.CDPRODUTO
                    WHERE
                        P.CDBARPRODUTO = :P_CDBARPRODUTO AND
                        PF.CDFILIAL = :P_CDFILIAL"; 
            
        } else{
            $sql = "SELECT DISTINCT PF.CDFILIAL,
                        P.CDPRODUTO,
                        P.CDARVPROD,
                        P.NMPRODUTO,
                        P.SGUNIDADE,
                        P.VRFATOCONV,
                        P.CDPRODESTO AS CDPRODMOVI,
                        P.NRORG,
                        ' ' AS CDALMOXARIFE,
                        ' ' AS CDLOCALESTOQ,
                        ' ' AS NRLOTEESTQ,
                        ' ' AS NRSUBLOTE,
                        0 AS VRUNILANCTO,
                        0 AS VRTOTLANCTO,
                        0 AS VRLANCTOEST,
                        0 AS VRUNITBRUT,
                        0 AS QTTOTLANCTO
                    FROM
                        PRODUTO P JOIN
                        PRODFILI PF ON P.CDPRODUTO = PF.CDPRODUTO
                    WHERE
                        P.CDPRODUTO = :P_CDPRODUTO AND
                        PF.CDFILIAL = :P_CDFILIAL"; 
        }
        
        
        $std = $this->connection->prepare($sql);
        $std->execute($parameters);
        $result = $std->fetchAll();
        if(isset($result[0])){
            return $result[0];
        } else{
            return null;
        }
    }
    
    public function insertLoteProduto($cdfilial, $cdproduto, $nrloteestq, $nrsublote, $dtlancamento, $dtvalilote, $dtfrabric){
        try{
            $params = array(
                'P_CDFILIAL'   => $cdfilial,
                'P_CDPRODUTO'  => $cdproduto,
                'P_NRLOTEESTQ' => $nrloteestq,
                'P_NRSUBLOTE'  => $nrsublote,
                'P_DTLANCAMENTO' => $dtlancamento,
                'P_DTVALILOTE' => $dtvalilote,
                'P_DTFABRPROD' => $dtfrabric
            );
            $query = "INSERT INTO LOTE
                    (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE, DTVALILOTE, DTFABRPROD)
                    (SELECT :P_CDFILIAL CDFILIAL, :P_NRLOTEESTQ NRLOTEESTQ, :P_NRSUBLOTE NRSUBLOTE, :P_CDPRODUTO CDPRODUTO,
                    'L' IDSTATLOTE, :P_DTLANCAMENTO DTENTRLOTE, :P_DTVALILOTE DTVALILOTE, :P_DTFABRPROD DTFABRPROD
                     FROM DUAL
                     MINUS
                     SELECT CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, 'L', :P_DTLANCAMENTO DTENTRLOTE, :P_DTVALILOTE DTVALILOTE, :P_DTFABRPROD DTFABRPROD
                     FROM LOTE
                     WHERE  :P_CDFILIAL   =  CDFILIAL     AND
                            :P_NRLOTEESTQ =  NRLOTEESTQ   AND
                            :P_NRSUBLOTE  =  NRSUBLOTE    AND
                            :P_CDPRODUTO  =  CDPRODUTO)";

            $this->entityManager->getConnection()->executeQuery($query, $params);
            
        }
         catch (\Exception $e) {
             var_dump($e->getMessage());die;
            return $e->getMessage();
        }
    }
    
    public function insertAlmoxarife($cdfilial, $cdalmoxarife, $dsalmoxarife, $nrorg){
        try{
            $params = array(
                'P_CDFILIAL'   => $cdfilial,
                'P_CDALMOXARIFE'  => $cdalmoxarife,
                'P_DSALMOXARIFE' => $dsalmoxarife,
                'P_NRORG'  => $nrorg
            );
            $query = "INSERT INTO ALMOXARIFADO
                    (CDFILIAL, CDALMOXARIFE, DSALMOXARIFE, NRORG)
                    (SELECT :P_CDFILIAL CDFILIAL, :P_CDALMOXARIFE CDALMOXARIFE, :P_DSALMOXARIFE DSALMOXARIFE, NRORG
                     FROM ALMOXARIFADO
                     MINUS
                     SELECT CDFILIAL, CDALMOXARIFE, DSALMOXARIFE, NRORG
                     FROM ALMOXARIFADO
                     WHERE  :P_CDFILIAL     =  CDFILIAL     AND
                            :P_CDALMOXARIFE  =  CDALMOXARIFE  AND
                            :P_NRORG        =  NRORG)";
                            
            $this->entityManager->getConnection()->executeQuery($query, $params);
            
        }
         catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
    public function insertLocalEstoque($cdfilial, $cdalmoxarife, $cdlocalestoq, $dslocalestoq, $estdesmemb, $nrorg){
        try{
            $params = array(
                'P_CDFILIAL'     => $cdfilial,
                'P_CDALMOXARIFE' => $cdalmoxarife,
                'P_CDLOCALESTOQ' => $cdlocalestoq,
                'P_DSLOCALESTOQ' => $dslocalestoq,
                'P_IDESTDESMEMB' => $estdesmemb,
                'P_NRORG'        => $nrorg
            );
            $query = "INSERT INTO LOCALESTOQUE
                    (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, DSLOCALESTOQ, IDESTDESMEMB, NRORG)
                    (SELECT :P_CDFILIAL CDFILIAL, :P_CDALMOXARIFE CDALMOXARIFE, :P_CDLOCALESTOQ CDLOCALESTOQ,
                    :P_DSLOCALESTOQ DSLOCALESTOQ, :P_IDESTDESMEMB IDESTDESMEMB, NRORG
                     FROM LOCALESTOQUE
                     MINUS
                     SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, DSLOCALESTOQ, IDESTDESMEMB, NRORG
                     FROM LOCALESTOQUE
                     WHERE  :P_CDFILIAL     =  CDFILIAL     AND
                            :P_CDALMOXARIFE =  CDALMOXARIFE AND
                            :P_CDLOCALESTOQ =  CDLOCALESTOQ AND
                            :P_NRORG        =  NRORG)";
                            
            $this->entityManager->getConnection()->executeQuery($query, $params);
            
        }
         catch (\Exception $e) {
            return $e->getMessage();
        }
    }
    
}