<?php
namespace Teknisa\EST\Modules\Lancamentos\Controllers;

use Teknisa\EST\Services\ValidacoesEstoqueService;
use \Teknisa\EST\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;

class Est11000ItemEntrada extends TeknisaCrud {

    protected $dataSourceName = "itlanctoest_entrada";
    protected $dataSourceNameToSave = "itlanctoest";
    //protected $parameterBagColumns = ['CDFILIMOVI','NRLANCESTQ'];

    protected $Est11000Service;
    protected $validacoesEstoqueService;

    protected $connection;

    public function __construct($crudService, $parameterBag, $Est11000Service, ValidacoesEstoqueService $validacoesEstoqueService, $entityManager) {
        parent::__construct($crudService,$parameterBag);

        $this->Est11000Service = $Est11000Service;
        $this->validacoesEstoqueService = $validacoesEstoqueService;

        $this->connection = $entityManager->getConnection();
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName = 'itlanctoest';
            
            parent::save($request,$response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
        /*
        $itens = $request->getDataSet()->getRows();
        $this->connection->beginTransaction();
        try {
            $this->Est11000Service->verificaInventarioRotativo($itens[0]['CDFILIMOVI'],
                                                              substr($itens[0]['DTLANCMOVI'], 0, 10));

            if($itens[0]['__is_new']) {
                $lancamento = $this->Est11000Service->insertItensForRetirada($itens, substr($itens[0]['DTLANCMOVI'], 0, 10),
                                                               $itens[0]['CDTIPORETI'],
                                                               $itens[0]['CDCENTCUST'],
                                                               $itens[0]['NRREQUESTO']);
            } else {
                $lancamento = $this->Est11000Service->editItemOfRetirada($itens[0]);
            }

            $this->validacoesEstoqueService->atualizaEstoque($lancamento["CDFILIAL"], $lancamento["NRLANCESTQ"]);

            $this->connection->commit();
        } catch(\Exception $e) {
            $this->connection->rollBack();
            $response->setError(new Error($e->getMessage(), 500));
        }
        */
    }

    public function delete(DTO\Request $request, DTO\Response $response) {
        $item = $request->getRow();
        $this->connection->beginTransaction();
        try {
            $this->Est11000Service->verificaInventarioRotativo($item['CDFILIMOVI'],
                                                              substr($item['DTLANCMOVI'], 0, 10));

            $this->Est11000Service->processDeleteItem($item);

            $this->validacoesEstoqueService->atualizaEstoque($item["CDFILIAL"], $item["NRLANCESTQ"]);

            $this->connection->commit();
        } catch(\Exception $e) {
            $this->connection->rollBack();
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}